%!octave 
%
%    Restricted Boltzmann machine based associative memory demo
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: main.m,v 1.20 2016/03/12 10:26:10 mechanoid Exp $

split_long_rows(0) ; % set nowrap

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
% загружаем учебный набор 

printf("[i] загружаем данные...\n"); 

[fl fc ft ] = data_path_img();

L = data_load_img(fl); % L={ X,Y,img_size,files_list}
C = data_load_img(fc); % L={ X,Y,img_size,files_list}

% пороговая бинаризация
Xl = ( L{1} > 0.5 ); 
Xc = ( C{1} > 0.5 ); 

sv = size(Xl,1) ; % размер образа (первого слоя)
%sh = min( 1000, size(Xl,2)*10) ; % размер скрытого слоя
sh = 300 ; % размер скрытого слоя

sz_net = [ sh,sv ] ; % размер сети

printf("[i] учебные: %i / контрольные: %i \n", size(Xl,2), size(Xc,2) );
printf("[i] размер сети: %i x %i \n", sv, sh );

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
% обучаем 

printf("[i] обучаем...\n") ;

W = rbm_weight_init(sz_net) ;

er=1;
er_min = 7e-2 ;
max_iter = 350; % максимальное количество эпох (полных циклов) обучения
[ W,er ] = rbm_training(Xl,Xc,W,er_min,max_iter) ;

printf("[i] сохраняем результат \n") ; 
save("-text","result/w.txt","W") ; % веса связей и сдвиги
save("-ascii","result/er.txt","er") ; % история изменения ошибки

plot_error(er,0) ; % рисуем историю изменения ошибки обучения

printf("[i] рисуем карту весов  \n") ; 
rbm_weight_visualizer(W{1},L{3}) ;

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
% тестируем

printf("[i] загружаем данные...\n");

T = data_load_img(ft) ; % T={ X,Y,img_size,files_list}
Xt = (T{1} > 0.5) ; % пороговая бинаризация

printf("[i] тестовые: %i \n", size(Xt,2) ) ;

printf("[i] выполняем RBM \n"); 
R = rbm_test(Xt,W) ;

printf("[i] сохраняем результат \n"); 
data_save_img(R,T{3},T{4}) ;


 


