%!octave 
%
%     MLP back propagation
%      
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.8.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: plot_error.m,v 1.4 2016/03/04 12:44:31 mechanoid Exp $

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% рисуем график изменения ошибки, 
% для равномерности передачи масштаба
% вся история изменения ошибки делится на две равные части
%
% er - значения ошибки
% n - номер картинки
%
function []=plot_error(er,n),
   pix_size="-S420,240";
   pix_font_size=10;
   pix_format="gif";
 
   se=length(er);
   se2=round( se / 2.0 );

   clf; hold on; grid on; set(gca,"fontsize",pix_font_size); 
   plot( [1:se2], er(1:se2), "-r" ) ;
   t=sprintf("iter: 1-%i, error %.5f", se2,er(se2) );
   title(t);
   file=sprintf("result/error%i-a.%s",n,pix_format);
   fm=sprintf("-d%s",pix_format);
   print(file,fm,pix_size) ;

   clf; hold on; grid on; set(gca,"fontsize",pix_font_size); 
   plot( [se2:se], er(se2:se), "-r" ) ;
   %t=sprintf("iter: %i-%i, error - start: %.3f, last: %.3f, max: %.3f", se2,se,er(se2),er(end),max(er(se2:end)));
   t=sprintf("iter: %i-%i, error %.5f", se2,se,er(end) );
   title(t);
   file=sprintf("result/error%i-b.%s",n,pix_format);
   fm=sprintf("-d%s",pix_format);
   print(file,fm,pix_size) ;

endfunction


% sl = [ 2 10 10 ] ;
% Er=rand(1,345);
% plot_error(Er,sl,0); 
