%!octave
%
%    Restricted Boltzmann machine based associative memory demo
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
%
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
%
% $Id: rbm_step.m,v 1.11 2016/03/11 11:16:19 mechanoid Exp $

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function [v h]=rbm_step(x,W), 
   h = rbm_layer_bin(x, W{1},  W{2}); % вычисляем состояние скрытого слоя 
   v = rbm_layer_bin(h,(W{1})',W{3}); % вычисляем состояние видимого слоя 
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=rbm_layer_bin(l,w,b), 
   s = w*l + b ; 
   p = act(s) ; % вычисляем вероятности изменения слоя 
   x = ( rand(size(p) ) < p ) ; % выставить состояния 1 нейронов слоя x с вероятностями p
   retval = x;
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% функция активации 
function retval=act(x),
  a=1.0; retval= 1.0 ./ (1.0+exp(-x*a)) ; % exp sigmoid

  %retval=log(1.0+exp(x)); % relu 

  %ex=exp(x); retval=ex./sum(ex); % softmax

  %retval=(tanh(x)+1.0)*0.5; % tanh sigmoid

endfunction

