%!octave 
%
%    Restricted Boltzmann machine based associative memory demo
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: rbm_test.m,v 1.9 2016/03/10 14:06:02 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=rbm_test(X,W),
   numb_ex = size(X,2); % количество примеров
   
   Xo = zeros(size(X));

   for i=1:numb_ex,
	  [ Xo(:,i) iter ] = rbm_run(X(:,i),W); % вычислить выход сети
	  printf("[i] %i / %i  - %i    \r",i,numb_ex,iter) ; 
   endfor
   printf("\n") ; 
   retval=Xo;
endfunction



% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% выполнение RBM
%
% x - вход
% W - матрица весов
%
function [v i] = rbm_run(x,W),
   max_iter = 150 ; % максимальное количество итераций 
   me=1e-3;

   for i=1:max_iter, 
	  [v h] = rbm_step(x,W) ; % вычисляем состояния слоёв
	  % если состояние выхода сети не изменилось то завершаем работу
	  %if v==x, break ; endif 
	  if msqe(x,v) < me, break ; endif 
	  x=v; % сохраняем текущее состояние выходного слоя
   endfor

endfunction


