#!/bin/sh
#
# $Id: run.sh,v 1.10 2016/03/12 17:53:58 mechanoid Exp $


#trn="data/images/numb/30x30/training"; 
#tst="data/images/numb/30x30/test3"; 

trn=$(cat data_path_img.m | grep -v '%' | grep 'fl *=' | sed 's/.*= *"//;s/index.txt.*//')
ctr=$(cat data_path_img.m | grep -v '%' | grep 'fc *=' | sed 's/.*= *"//;s/index.txt.*//')
tst=$(cat data_path_img.m | grep -v '%' | grep 'ft *=' | sed 's/.*= *"//;s/index.txt.*//')

echo "учебный: $trn"
echo "контрольный: $ctr"
echo "тестовый: $tst"

rm -vfr ./result > /dev/null
mkdir -p ./result/map

octave-cli main.m 2> ./result/err.log

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  

cd result

exec 1> ./_REPORT.html
 
echo '<!doctype html>' 
echo '<html><head><meta charset="utf-8"/><style> img { border: 1px solid #000; } hr { border:1px solid #000;} table {width:700px;} td:first-child { color:#f00; text-align:right; } td { text-align:center; } </style> </head><body>' 

echo '<span style="color:#f00;font-weight:bold;">'
date
echo '</span>'

echo '<h1>Ассоциативная память на основе RBM</h1>' 

echo '<h2>учебный набор</h2>' 
for f in ../$trn/*.png; do
   echo "<img src='$f'/>" 
done

echo "<p/>" 

echo '<h2>контрольный набор</h2>' 
for f in ../$ctr/*.png; do
   echo "<img src='$f'/>" 
done

echo '<h2>конфигурация сети</h2>'

echo '<pre style="font-size:14pt;">'
echo "load w.txt; printf('visual:\t%i\nhidden:\t%i\n',size(W{1}'))"  | octave-cli --silent
echo '</pre>'

echo "<p/>" 

echo '<h2>результат работы</h2>' 


fft=(`ls ../$tst/*.png`)
ffr=(`ls *.png`)

i_max=${#fft[*]}

i_batch=15

i0=0
i1=$( expr $i_batch - 1 )

while  [ $i0 -lt $i_max ] ; do

   if [ $i1 -ge $i_max ];then i1=$( expr $i_max - 1 ); fi

   echo '<table><tbody>'
   echo '<tr><td>вход:</td>'

   for i in `seq $i0 $i1`; do
	  echo "<td><img src='${fft[i]}'/></td>" 
   done

   echo '</tr><tr><td>выход:</td>'

   for i in `seq $i0 $i1`; do
	  echo "<td><img src='${ffr[i]}'/></td>" 
   done

   echo '</tr>'
   echo '</tbody></table><p/>'

   i0=$( expr $i1 + 1 )
   i1=$( expr $i1 + $i_batch )

done




echo "<p/>" 

echo '<h2>история изменения ошибки обучения</h2>'
for f in error*; do
   echo "<img src='$f'/>" 
done

echo "<p/>" 

echo '<h2>карта весов</h2>'

echo 'по количеству нейронов второго (hidden) слоя<p/>'

for f in map/*.png; do
   echo "<img src='$f'/>" 
done
 
echo '</body></html>'
 
# exec 1>&-

